from spread_core.mqtt.spread.topic import State
from spread_core.mqtt.spread.variable import Variable
from .enginery import Enginery, _EngineryFunit


class Sensor(Enginery):
    def on_state(self, topic: State, variable: Variable):
        super(Sensor, self).on_state(topic, variable)
        if topic.entity_address.funit_type == On:
            for _subginery in self._subgineries:
                _subginery.on_sensor_on_off(self, is_on=None if variable.invalid else variable.value)


class LightSensor(Sensor):
    pass


class PresenceSensor(Sensor):
    pass


class _SensorFunit(_EngineryFunit):
    entity_type = Sensor


Sensor.funit_class = _SensorFunit


class On(_SensorFunit):
    pass


class HoldTime(_SensorFunit):
    entity_type = PresenceSensor
