from spread_core.errors.project_errors import ProjectError
from spread_core.tools import utils
from .engineries.enginery import Enginery
from .providers import Provider
from .subgineries import Subginery


def generate_enginery(project_id, data):
    def separator(subclass): return issubclass(subclass, Enginery) and subclass.__name__ == data['type']
    res = utils.get_subclass(Enginery, separator)

    if res:
        return res(project_id, data)
    else:
        raise ProjectError(f'Unknown enginery type "{data.get("type", "unknownType")}({data.get("id", "?")})"')


def generate_subginery(project_id, data):
    def separator(subclass): return issubclass(subclass, Subginery) and subclass.__name__ == data['type']
    res = utils.get_subclass(Subginery, separator)

    if res:
        return res(project_id, data)
    else:
        raise ProjectError(f'Unknown subginery type  "{data.get("type", "unknownType")}({data.get("id", "?")})"')


def generate_provider(data):
    def separator(subclass): return issubclass(subclass, Provider) and subclass.__name__ == data['type']
    res = utils.get_subclass(Provider, separator)

    if res:
        return res(data)
    else:
        raise ProjectError(f'Unknown provider type  "{data.get("type", "unknownType")}({data.get("id", "?")})"')
