from spread_knx.interface import KnxInterface

import spread_knx as knx

from ..managers import Manager
from . import provdiers


class Knx(Manager):
    def __init__(self, p_id, m_id):
        super().__init__(p_id, m_id)
        self._server_id = None
        self._broadcast = None
        self.dump_topic = None
        self.send_topic = None

    def set_interface(self):
        self.send_interface = KnxInterface(self.mqttc)

    def on_external_command(self, command, response, *args):
        pass

    def on_event(self, event_data: knx.commands.KnxFrame):
        for provider in self.providers.values():
            if isinstance(provider, provdiers.KnxProvider):
                if event_data.address == provider.address.state or event_data.address == provider.address.control:
                    dptu = provider.def_state.empty()
                    dptu.fill(event_data.dptu.frame)
                    provider.on_request_answer(dptu)
