import spread_core.mqtt as mqtt
from spread_core.bam.handling.scripter import Scripter
from spread_core.tools.service_launcher import Launcher, logging


class ScriptLauncher(Launcher):
    _def_start_delay = 0
    _dumped = False

    @property
    def manager(self):
        if self._manager is None:
            self._manager = Scripter(self.project_id, self.mqttc)
        return self._manager

    def on_message(self, mosq, obj, msg):
        super(ScriptLauncher, self).on_message(mosq, obj, msg)
        try:
            topic = mqtt.of(msg.topic)
            if isinstance(topic, mqtt.spread.topic.SpreadTopic):
                variable = mqtt.spread.variable.Variable.of(msg.payload)
                self._manager.on_message(topic, variable)

        except BaseException as ex:
            logging.exception(ex)


def run():
    ScriptLauncher().connect()


if __name__ == '__main__':
    run()
