from . import address


class SpreadTopic:
    protocol = 'Spread'
    action = None

    def __init__(self, entity_address: address.EntityAddress):
        self.entity_address = entity_address

    def __str__(self): return '/'.join(str(i) for i in [self.protocol, self.action, self.entity_address])
    def __repr__(self): return self.__str__()
    def __eq__(self, other): return isinstance(other, self.__class__) and self.__str__() == other.__str__()

    @classmethod
    def of_provider(cls, entity, funit_type='+'):
        return cls(address.ProviderAddress.of(entity, funit_type))

    @classmethod
    def of_manager(cls, entity, funit_type='+'):
        return cls(address.ManagerAddress.of(entity, funit_type))


class State(SpreadTopic):
    action = 'State'


class Renew(SpreadTopic):
    action = 'Renew'


class Set(SpreadTopic):
    action = 'Set'


class Reply:
    protocol = SpreadTopic.protocol
    action = 'Reply'

    def __init__(self, project_id, session_id):
        self.project_id = project_id
        self.session_id = session_id

    def __str__(self):
        return '/'.join(str(i) for i in [self.protocol, self.action, self.project_id, self.session_id])
