from .can_packet import CanSend, CanDump
from .rapida import commands as rapida_commands
from .rapida import responses as rapida_responses
from ..payloads.rapida import ServicePacket


class RapidaSend(CanSend):
    def __init__(self, module_type, module_address, end_frame, **kwargs):
        super(RapidaSend, self).__init__(module_type, module_address, end_frame, cmd=1, **kwargs)

    @property
    def frame(self):
        return ((1 << 7) + self.module_type).to_bytes(1, 'big') + self.end_frame


class RapidaDump(CanDump):
    cmd = 1

    @property
    def command_byte(self):
        return self.frame[1]

    @property
    def data(self):
        return self.frame[2:]

    @property
    def payload(self):
        rs = rapida_responses.of(self.data, self.command_byte)
        if rs.__class__ == rapida_responses.Response:
            cm = rapida_commands.of(self.data, self.command_byte)
            if cm.__class__ != rapida_commands.Command and cm.__class__ != rapida_commands.Query:
                return ServicePacket(self, cm)
        return ServicePacket(self, rs)
