from .general import _StandardInstanceCommand
from .. import command


class _Query(_StandardInstanceCommand):
    _inputdev = True
    _response = command.Response


class _Command(_StandardInstanceCommand):
    _inputdev = True
    _uses_dtr0 = True
    _sendtwice = True


class SetShortTime(_Command):
    _opcode = 0x00


class SetDoubleTime(_Command):
    _opcode = 0x01


class SetRepeatTime(_Command):
    _opcode = 0x02


class SetStuckTime(_Command):
    _opcode = 0x03


class QueryShortTime(_Query):
    _funit_type = ['ShortTime']
    _opcode = 0x0a


class QueryShortTimeMin(_Query):
    _funit_type = ['ShortTimeMin']
    _opcode = 0x0b


class QueryDoubleTime(_Query):
    _funit_type = ['DoubleTime']
    _opcode = 0x0c


class QueryDoubleTimeMin(_Query):
    _funit_type = ['DoubleTimeMin']
    _opcode = 0x0d


class QueryRepeatTime(_Query):
    _funit_type = ['RepeatTime']
    _opcode = 0x0e


class QueryStuckTime(_Query):
    _funit_type = ['StuckTime']
    _opcode = 0x0f
