# import logging
# import select
# import threading
#
# import can
#
# import spread_core.mqtt as mqtt
# import spread_core.tools.settings as settings
# from spread_core.protocols.can_utils.can_packet import CanDump
# from spread_core.protocols.can_utils.dali_packet import DaliSend, DaliDump
# from spread_core.tools.service_launcher import Launcher
#
# _can_logger = logging.getLogger('can.interfaces.socketcan.socketcan')
# _can_logger.level = logging.WARNING
# _can_logger.getChild("rx").level = logging.WARNING
#
#
# class ErrorPacket(BaseException):
#     pass
#
#
# class CanAdapter(Launcher):
#     _dumped = False
#     _def_start_delay = 0
#
#     def __init__(self):
#         self._manager = self
#         self._bus = None
#
#         super(CanAdapter, self).__init__()
#
#     @property
#     def dump_topic(self):
#         return '/'.join([mqtt.const.BUS, mqtt.const.DUMP, settings.config[settings.SUBTOPIC_DALI], '{}', '{}'])
#
#     @property
#     def can_name(self):
#         return settings.config[settings.CAN_INTERFACE]
#
#     @property
#     def bus(self) -> can.Bus:
#         if self._bus is None:
#             self._bus = can.Bus(channel=self.can_name, bustype='socketcan')
#         return self._bus
#
#     def start(self):
#         threading.Thread(name=self.can_name, target=self.start_can).start()
#         self.subscribe('/'.join([mqtt.const.BUS, mqtt.const.SEND, settings.config[settings.SUBTOPIC_DALI], '+', '+']))
#
#     def on_message(self, mosq, obj, msg):
#         topic = mqtt.of(msg.topic)
#         if isinstance(topic, mqtt.bus.TopicBus):
#             data = msg.payload.decode()
#             parts = data.split('#')
#             can_send = DaliSend(1, topic.module_id, topic.channel_id, bytes.fromhex(parts[0]))
#             if len(parts) > 1:
#                 flags = parts[1].split(':')
#                 can_send.need_answer = 'W' in flags
#                 can_send.send_twice = 'D' in flags
#             message = can.Message(arbitration_id=can_send.arbitration_id, data=can_send.frame, extended_id=False)
#             self.bus.send(message)
#             logging.debug(f'{can_send.payload.__str__().ljust(80, " ")} {topic}: {data}')
#
#     def start_can(self):
#         while True:
#             try:
#                 read_sockets, write_sockets, error_sockets = select.select([self.bus], [], [])
#             except ValueError:
#                 return
#             for sock in read_sockets:
#                 if sock == self.bus:
#                     try:
#                         for msg in self.bus:
#                             try:
#                                 packet = CanDump.can_dump(msg)
#                                 broker_data = ''
#                                 if isinstance(packet, DaliDump):
#                                     topic = self.dump_topic.format(packet.module_address, packet.channel)
#                                     if len(packet.data) == 0:
#                                         data = '#W'
#                                     else:
#                                         data = ''.join(hex(b)[2:].rjust(2, '0').upper() for b in packet.data)
#                                     self.mqttc.publish(topic, data)
#
#                                     broker_data = f'{topic}: {data}'
#                                 logging.debug(f'{packet.payload.__str__().ljust(80, " ")} {broker_data}')
#                             except BaseException as ex:
#                                 logging.exception(ex)
#                     except ValueError:
#                         return
#
#     def on_exit(self, sig, frame):
#         try:
#             self.bus.shutdown()
#         except BaseException as ex:
#             logging.exception(ex)
#         super(CanAdapter, self).on_exit(sig, frame)
#
#
# def run():
#     CanAdapter()
#
#
# if __name__ == '__main__':
#     run()
