import json
import os


def run():
    config = read('lighting_old.json')
    map = read('matching.json')
    map = {i['oldId']: i['newId'] for i in map['matches']}

    new = {}
    for type, objects in config.items():
        if type == 'LightingArea':
            new.setdefault(type, {})
            for old_id, data in objects.items():
                new[type][map[int(old_id)]] = data

    with open('lighting.json', 'w') as outfile:
        outfile.write(json.dumps(new, indent=2))

    print(f'Config file saved as "{os.path.abspath("lighting.json")}"')


def read(path):
    with open(path, 'r') as file:
        data = file.read()

    return json.loads(data)


if __name__ == '__main__':
    run()
