import argparse
import json

from spread_core.bam.engineries.lighting_area import LightingArea, Profiles, CurrentProfile

LA = LightingArea.__name__
PROF = Profiles.funit_type
DEF_PR_ID = CurrentProfile.DEFAULT


def run():
    parser = argparse.ArgumentParser(description='Create profiles in LA`s dump')
    parser.add_argument('dump', help="dump file")
    args = parser.parse_args()

    try:
        with open(args.dump) as fs:
            data = json.loads(fs.read())
    except BaseException as ex:
        print(str(ex))
    else:
        for la_id in data[LA]:
            data[LA][la_id].setdefault(PROF, {})
            data[LA][la_id][PROF].setdefault(DEF_PR_ID, {})

            item = data[LA][la_id].copy()
            data[LA][la_id][PROF][DEF_PR_ID].update({
                key: data[LA][la_id].pop(key)
                for key in item.keys()
                if key in LightingArea.PROFILE_KEYS
            })

        with open(args.dump, 'w') as fs:
            fs.write(json.dumps(data, indent=2))


if __name__ == '__main__':
    run()
