import json
import os
import sys

if len(sys.argv) < 2:
    print('Путь до файла не указан в параметрах!')
elif not os.path.isfile(sys.argv[1]):
    print(f'Файл "{sys.argv[1]}" не существует')
else:
    config_path = sys.argv[1]
    with open(config_path, 'r') as _file:
        config = _file.read()
        config = json.loads(config)

    _id = 1

    for location in config:
        location['id'] = location.pop('locationID')
        location['triggers'] = []
        for task in location.pop('tasks'):
            for trigger in task['triggers']:
                for action in trigger['actions']:
                    action['id'] = _id
                    topic = action['topic'].split('/')
                    topic = topic[:3] + ['Equipment', 'Lighting'] + topic[3:]
                    action['topic'] = '/'.join(topic)
                trigger['id'] = _id
                trigger['type'] = task['type']
                location['triggers'].append(trigger)
                _id += 1

    os.rename(config_path, config_path + '_old')
    with open(config_path, 'w') as _file:
        _file.write(json.dumps(config, indent=2))
    print(config_path)

