import argparse
import os
import shutil


def run():
    parser = argparse.ArgumentParser(description='Update spread config files')
    parser.add_argument('-f', '--forced', dest='forced', action='store_true', help='Replace ALL configuration files')
    parser.add_argument('--ctp', dest='ctp', type=open, default=None, help='Ctp-file path')
    try:
        args = parser.parse_args()
    except FileNotFoundError as ex:
        print(str(ex))
        return

    if args.ctp and args.ctp.name != '/var/project/throne-project.ctp':
        shutil.copyfile(args.ctp.name, '/var/project/throne-project.ctp')

    os.system('curl 127.0.0.1/spread/project/reread_ctp/?force=%s' % args.forced)

    os.system('sudo supervisorctl reread')
    os.system('sudo supervisorctl update')

    os.system('sudo supervisorctl restart ' + ' '.join(
        s.split(' ')[0]
        for s in os.popen('sudo supervisorctl status | grep "^spread_"').readlines()
    ))


if __name__ == '__main__':
    run()
