from django.core.management.base import BaseCommand

from spread_dashboard.project.bam import Project
from spread_dashboard.scheduler.models import SchBase, Holiday


class Command(BaseCommand):
    help = 'Updates database from local files'

    def add_arguments(self, parser):
        parser.add_argument('--all', action='store_true', help='Does need fill all data')
        parser.add_argument('-c', '--ctp', action='store_true', help='Does need fill a project data')
        parser.add_argument('-t', '--tasks', action='store_true', help='Does need fill a scheduler dump')
        parser.add_argument('-cal', '--calendar', action='store_true', help='Does need fill a calendar dump')

    def handle(self, *args, **options):
        try:
            if options.get('ctp') or options.get('all'):
                Project.read_ctp()
        except BaseException as ex:
            print('error ctp filling')

        try:
            if options.get('calendar') or options.get('all'):
                Holiday.fill()
        except BaseException as ex:
            print('error calendar filling')

        try:
            if options.get('tasks') or options.get('all'):
                SchBase.fill()
        except BaseException as ex:
            print('error tasks filling')
