# Generated by Django 3.0.10 on 2021-02-24 12:08

from django.db import migrations, models
import django.db.models.deletion
import jsonfield.fields


class Migration(migrations.Migration):

    initial = True

    dependencies = [
    ]

    operations = [
        migrations.CreateModel(
            name='CanAdapter',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('include', models.CharField(editable=False, max_length=255)),
                ('canInterface', models.CharField(max_length=7, verbose_name='Название Can-интерфейса')),
                ('subtopicCan', models.CharField(max_length=25, verbose_name='Can-топик')),
                ('subtopicDali', models.CharField(max_length=25, verbose_name='Dali-топик')),
                ('subtopicModbus', models.CharField(max_length=25, verbose_name='Modbus-топик')),
                ('canReopenTimeout', models.PositiveIntegerField(default=1000, help_text='Время в миллисекундах', verbose_name='Интервал переоткрытия интерфейса')),
                ('logLevel', models.IntegerField(blank=True, choices=[('', 'Общий'), (1, '1-Супер краткий'), (2, '2-Очень краткий'), (3, '3-Весьма краткий'), (4, '4-Умеренный'), (5, '5-Умеренно-подробный'), (6, '6-Весьма подробный'), (7, '7-Очень подробный'), (8, '8-Пожиратель памяти')], verbose_name='Уровень логирования')),
                ('enableSysLog', models.BooleanField(default=False, verbose_name='Системные логи')),
                ('enableCanSendTopic', models.BooleanField(default=False, verbose_name='Трансляция в CanSend-топик')),
                ('enableCanDumpTopic', models.BooleanField(default=False, verbose_name='Трансляция в CanDump-топик')),
                ('appendTimestamp', models.BooleanField(default=True, verbose_name='Указывать Timestamp')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='DaliManager',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('include', models.CharField(editable=False, max_length=255)),
                ('managerID', models.IntegerField(verbose_name='Идентификатор')),
                ('logLevel', models.IntegerField(blank=True, choices=[('', 'Общий'), (1, '1-Краткий'), (2, '2-Подробный')], verbose_name='Уровень логирования')),
                ('dump', models.CharField(max_length=255, verbose_name='Файл дампа')),
                ('communicateTimeout', models.FloatField(default=1.0, verbose_name='Время ожидания ответа')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='Dashboard',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('include', models.CharField(editable=False, max_length=255)),
                ('port', models.PositiveIntegerField(default=55582, serialize=False, verbose_name='nginx-порт')),
                ('httpRoot', models.CharField(default='spread', max_length=255)),
                ('restartTimeout', models.PositiveIntegerField(default=10)),
                ('tasks', models.CharField(max_length=255)),
                ('calendar', models.CharField(max_length=255)),
                ('logLevel', models.IntegerField(blank=True, choices=[('', 'Общий'), (1, '1-Краткий'), (2, '2-Подробный')], verbose_name='Уровень логирования')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='Enginery',
            fields=[
                ('id', models.PositiveIntegerField(primary_key=True, serialize=False)),
                ('type', models.CharField(max_length=255)),
                ('name', models.CharField(blank=True, max_length=255)),
                ('attributes', jsonfield.fields.JSONField()),
                ('key', models.CharField(max_length=64)),
                ('recipe', jsonfield.fields.JSONField(blank=True)),
                ('label', models.CharField(max_length=16)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='EventsSqlite',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('include', models.CharField(editable=False, max_length=255)),
                ('database', models.CharField(max_length=255)),
                ('enableSysLog', models.BooleanField(default=False)),
                ('tickRate', models.PositiveIntegerField(default=60000)),
                ('failureOffset', models.PositiveIntegerField(default=1000)),
                ('sizeLimit', models.PositiveIntegerField(default=256)),
                ('logLevel', models.IntegerField(blank=True, choices=[('', 'Общий'), (1, '1-Супер краткий'), (2, '2-Очень краткий'), (3, '3-Весьма краткий'), (4, '4-Умеренный'), (5, '5-Умеренно-подробный'), (6, '6-Весьма подробный'), (7, '7-Очень подробный'), (8, '8-Пожиратель памяти')], verbose_name='Уровень логирования')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='Frontier',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('include', models.CharField(editable=False, max_length=255)),
                ('serverID', models.IntegerField()),
                ('logLevel', models.IntegerField(blank=True, choices=[('', 'Общий'), (1, '1-Краткий'), (2, '2-Подробный')], verbose_name='Уровень логирования')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='Holiday',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('date', models.DateField(unique=True)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='LightingEquipment',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('include', models.CharField(editable=False, max_length=255)),
                ('dump', models.CharField(max_length=255, verbose_name='Файл дампа')),
                ('logLevel', models.IntegerField(blank=True, choices=[('', 'Общий'), (1, '1-Краткий'), (2, '2-Подробный')], verbose_name='Уровень логирования')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='Location',
            fields=[
                ('id', models.PositiveIntegerField(primary_key=True, serialize=False)),
                ('name', models.CharField(blank=True, max_length=255)),
                ('attributes', jsonfield.fields.JSONField()),
                ('key', models.CharField(max_length=64)),
                ('scheduled', models.BooleanField()),
                ('navigations', jsonfield.fields.JSONField(blank=True, default=[])),
                ('models', jsonfield.fields.JSONField(blank=True, default=[])),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='LomManager',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('include', models.CharField(editable=False, max_length=255)),
                ('managerID', models.IntegerField(verbose_name='Идентификатор')),
                ('logLevel', models.IntegerField(blank=True, choices=[('', 'Общий'), (1, '1-Краткий'), (2, '2-Подробный')], verbose_name='Уровень логирования')),
                ('dump', models.CharField(max_length=255, verbose_name='Файл дампа')),
                ('profiles', models.CharField(max_length=255, verbose_name='Файл профилей')),
                ('tempDimmingPeriod', models.PositiveIntegerField(default=30, verbose_name='Длительность временного диммирования')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='Manager',
            fields=[
                ('id', models.PositiveIntegerField(primary_key=True, serialize=False)),
                ('type', models.CharField(max_length=255)),
                ('name', models.CharField(blank=True, max_length=255)),
                ('attributes', jsonfield.fields.JSONField()),
                ('key', models.CharField(max_length=64)),
                ('serverID', models.PositiveIntegerField()),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='MercuryManager',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('include', models.CharField(editable=False, max_length=255)),
                ('managerID', models.IntegerField(verbose_name='Идентификатор')),
                ('logLevel', models.IntegerField(blank=True, choices=[('', 'Общий'), (1, '1-Краткий'), (2, '2-Подробный')], verbose_name='Уровень логирования')),
                ('communicateTimeout', models.PositiveIntegerField(default=1, verbose_name='Время ожидания ответа')),
                ('hexed', jsonfield.fields.JSONField(blank=True, default=[], verbose_name='Адреса счётчиков с индексом "D"')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='Projector',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('include', models.CharField(editable=False, max_length=255)),
                ('ctpPath', models.CharField(default='/var/project/throne-project.ctp', max_length=255)),
                ('mosquittoDB', models.CharField(default='/var/lib/mosquitto/mosquitto.db', max_length=255)),
                ('logLevel', models.IntegerField(blank=True, choices=[('', 'Общий'), (1, '1-Краткий'), (2, '2-Подробный')], verbose_name='Уровень логирования')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='Provider',
            fields=[
                ('id', models.PositiveIntegerField(primary_key=True, serialize=False)),
                ('type', models.CharField(max_length=255)),
                ('name', models.CharField(blank=True, max_length=255)),
                ('attributes', jsonfield.fields.JSONField()),
                ('key', models.CharField(max_length=64)),
                ('managerID', models.PositiveIntegerField()),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='Scheduler',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('include', models.CharField(editable=False, max_length=255)),
                ('tasks', models.CharField(max_length=255)),
                ('calendar', models.CharField(max_length=255)),
                ('logLevel', models.IntegerField(blank=True, choices=[('', 'Общий'), (1, '1-Краткий'), (2, '2-Подробный')], verbose_name='Уровень логирования')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='SchLocation',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('enabled', models.BooleanField(default=False)),
                ('name', models.CharField(max_length=255)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='Scripter',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('include', models.CharField(editable=False, max_length=255)),
                ('triggers', models.CharField(max_length=255)),
                ('calendar', models.CharField(max_length=255)),
                ('logLevel', models.IntegerField(blank=True, choices=[('', 'Общий'), (1, '1-Краткий'), (2, '2-Подробный')], verbose_name='Уровень логирования')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='Subginery',
            fields=[
                ('id', models.PositiveIntegerField(primary_key=True, serialize=False)),
                ('type', models.CharField(max_length=255)),
                ('name', models.CharField(blank=True, max_length=255)),
                ('attributes', jsonfield.fields.JSONField()),
                ('key', models.CharField(max_length=64)),
                ('locationID', models.PositiveIntegerField()),
                ('engineries', jsonfield.fields.JSONField(blank=True)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='TcpAdapter',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('include', models.CharField(editable=False, max_length=255)),
                ('subtopic', models.CharField(max_length=25)),
                ('host', models.GenericIPAddressField(default='', verbose_name='Адрес Moxa-адаптера')),
                ('port', models.PositiveIntegerField(default=4001, verbose_name='Порт Moxa-адаптера')),
                ('timeout', models.FloatField(default=0.7, verbose_name='Время ожидания ответа')),
                ('killTimeout', models.FloatField(default=3, verbose_name='Время простоя TCP-соединения')),
                ('logLevel', models.IntegerField(blank=True, choices=[('', 'Общий'), (1, '1-Краткий'), (2, '2-Подробный')], verbose_name='Уровень логирования')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='SchTrigger',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('type', models.CharField(max_length=255)),
                ('time', models.TimeField()),
                ('location', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, serialize=False, to='spread_dashboard.SchLocation')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='SchAction',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('type', models.CharField(default='broker', editable=False, max_length=255)),
                ('topic', models.CharField(max_length=255)),
                ('value', jsonfield.fields.JSONField()),
                ('trigger', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, serialize=False, to='spread_dashboard.SchTrigger')),
            ],
            options={
                'abstract': False,
            },
        ),
    ]
