# Generated by Django 3.0.10 on 2021-03-09 10:14

import datetime
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    dependencies = [
        ('spread_dashboard', '0001_initial'),
    ]

    operations = [
        migrations.CreateModel(
            name='Cycle',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('name', models.CharField(default='Новый цикл', max_length=30, verbose_name='Название цикла')),
                ('period', models.PositiveIntegerField(default=0, verbose_name='Длительность (дней)')),
                ('duration', models.PositiveIntegerField(default=50, verbose_name='Рассвет/закат (мин)')),
                ('startLevel', models.PositiveIntegerField(default=25, verbose_name='Начальная яркость (%)')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='Cycler',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('include', models.CharField(editable=False, max_length=255)),
                ('data', models.CharField(max_length=255)),
                ('logLevel', models.IntegerField(blank=True, choices=[('', 'Общий'), (1, '1-Краткий'), (2, '2-Подробный')], verbose_name='Уровень логирования')),
                ('fadeTime', models.FloatField(choices=[(0.7, 0.7), (1.0, 1.0), (1.4, 1.4), (2.0, 2.0), (2.8, 2.8), (4.0, 4.0), (5.7, 5.7), (8.0, 8.0), (11.3, 11.3), (16.0, 16.0), (22.6, 22.6), (32.0, 32.0), (45.3, 45.3), (64.0, 64.0), (90.5, 90.5)], default=90.5)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.AddField(
            model_name='dashboard',
            name='cycles',
            field=models.CharField(default='', max_length=255),
        ),
        migrations.AddField(
            model_name='location',
            name='incubated',
            field=models.BooleanField(default=False),
        ),
        migrations.CreateModel(
            name='Incubator',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('startTime', models.DateField(default=datetime.date.today, max_length=16, verbose_name='Сегодня')),
                ('active', models.BooleanField(default=False)),
                ('recursive', models.BooleanField(default=False, verbose_name='Перезапускать')),
                ('cycle', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, to='spread_dashboard.Cycle', verbose_name='Цикл')),
                ('location', models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, to='spread_dashboard.Location')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='IncTrigger',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('day', models.PositiveIntegerField()),
                ('time', models.TimeField()),
                ('level', models.PositiveIntegerField()),
                ('cycle', models.ForeignKey(editable=False, on_delete=django.db.models.deletion.CASCADE, to='spread_dashboard.Cycle')),
            ],
            options={
                'abstract': False,
            },
        ),
    ]
