# Generated by Django 3.0.10 on 2021-11-22 08:16

import django.core.validators
from django.db import migrations, models


def generate_default_users(apps, schema_editor):
    try:
        from django.contrib.auth.models import User
        user, created = User.objects.update_or_create(username='user')
        if created:
            user.set_password('user')
            user.save()

        user, created = User.objects.update_or_create(username='admin', defaults={'is_staff': True, 'is_superuser': True})
        if created:
            user.set_password('proadmin')
            user.save()
    except BaseException as ex:
        print('Default users generate error: \n%s' % ex)


class Migration(migrations.Migration):

    dependencies = [
        ('spread_dashboard', '0011_pollRate_timestamp_fields'),
    ]

    operations = [
        migrations.RunPython(generate_default_users),
    ]
