from django.utils.translation import gettext_lazy as _
from django.db import models


def IncludeField() -> models.CharField:
    return models.CharField(max_length=255, editable=False)


def DumpField() -> models.CharField:
    return models.CharField(max_length=255, verbose_name=_('project_fields_dumpField'))


def LogLevelCommonField() -> models.IntegerField:
    choices = [(1, _('project_fields_LogLevelCommonField_1')), (2, _('project_fields_LogLevelCommonField_2'))]
    return models.IntegerField(default=1, choices=choices, verbose_name=_('project_fields_LogLevelCommonField'))


def LogLevelField() -> models.IntegerField:
    choices = [
        ('', _('project_fields_LogLevelCommonField_0')),
        (1, _('project_fields_LogLevelCommonField_1')),
        (2, _('project_fields_LogLevelCommonField_2'))
    ]

    return models.IntegerField(blank=True, choices=choices, verbose_name=_('project_fields_LogLevelCommonField'))


def LogLevel2Field() -> models.IntegerField:
    choices = [
        ('', _('project_fields_LogLevelCommonField_0')),
        (1, _('project_fields_LogLevel2Field_1')),
        (2, _('project_fields_LogLevel2Field_2')),
        (3, _('project_fields_LogLevel2Field_3')),
        (4, _('project_fields_LogLevel2Field_4')),
        (5, _('project_fields_LogLevel2Field_5')),
        (6, _('project_fields_LogLevel2Field_6')),
        (7, _('project_fields_LogLevel2Field_7')),
        (8, _('project_fields_LogLevel2Field_8')),
        (9, _('project_fields_LogLevel2Field_9')),
    ]

    return models.IntegerField(blank=True, choices=choices, verbose_name=_('project_fields_LogLevelCommonField'))


def enable_sys_log() -> models.BooleanField:
    return models.BooleanField(
        default=False,
        verbose_name=_('project_configs_enableSysLog'),
        help_text=_('project_configs_enableSysLog_help'),
    )


def append_timestamp() -> models.BooleanField:
    return models.BooleanField(
        default=True,
        verbose_name=_('project_configs_appendTimestamp'),
        help_text=_('project_configs_appendTimestamp_help')
    )
