import logging
import logging.config
import sys

from spread_dashboard.settings import *

DEBUG = True
ROOT_URLCONF = 'urls'

DEFAULT_LOGGING = {
    'version': 1,
    'disable_existing_loggers': False,
    'formatters': {
        'default': {'format': u'%(levelname)-8s [%(asctime)s]  %(message)s'},
    },
    'handlers': {
        'console': {
            'level': 'DEBUG',
            'formatter': 'default',
            'class': 'logging.StreamHandler',
            'stream': sys.stdout
        },
    },
    'root': {
        'handlers': ['console'],
        'level': 'DEBUG',
    },
    'loggers': {
        'daphne.ws_protocol': {'level': logging.INFO},
        'asyncio': {'level': logging.INFO},
        'daphne.http_protocol': {'level': logging.INFO},
        'can.interfaces.socketcan.socketcan': {'level': logging.WARNING},
    }
}

logging.basicConfig(format=u'%(levelname)-8s [%(asctime)s]  %(message)s', level=logging.DEBUG, stream=sys.stdout)
logging.config.dictConfig(DEFAULT_LOGGING)
