var copyTo, copyFrom, onRemove;

const client = init_client(
    broker,
    function onConnect() {
        console.log('MQTT Connected');
        client.subscribe(CYCLES + '+', {});
    },
    function onMessage(topic, message) {
        console.log('Recv: ', topic, message);

        if (onRemove && message !== '' && topic.startsWith(onRemove)) {
            const remove = topic => client.send(topic, '', 0, true);
            remove(topic);
        } else if (topic.startsWith(CYCLES)) {
            const id = topic.substr(CYCLES.length).split('/')[0];
            update(id, message);
        }

        if (copyFrom && topic.startsWith(CYCLES + copyFrom)) {
            const makeCopy = function(topic, data) {
                client.send(topic, JSON.stringify(data), 0, true);
            };

            var arr = topic.split('/');
            arr[arr.indexOf('Cycles') + 1] = copyTo;

            if (topic === CYCLES + copyFrom) {
                message['name'] += ' (copy)';
            }
            makeCopy(arr.join('/'), message);
        }
    }
);

function nextId() {
    let ids = [0];
    $('.content-items tr').each((_, node) => {
        if (node.id.startsWith('cycle-')) {
            ids.push(node.id.substr('cycle-'.length));
        }
    });

    return Math.max(...ids) + 1;
}

function update(id, data) {
    const table = $('table.content-items');

    var rows = table.find('#cycle-' + id);

    if (data) {
        if (rows.length === 0) {
            const row = table[0].insertRow();
            row.innerHTML = $('#template-row')[0].innerHTML;
            row.id = 'cycle-' + id;
            row.classList.add('cycle-row');
            rows.push(row);
        }

        for (var key in data) {
            rows.find('.' + key).text(data[key]);
        }
    } else {
        rows.remove();
    }
}

function addCycle() {
    document.location = 'edit/' + nextId();
}

function copyCycle(btn) {
    $(btn).parents('.cycle-row').each((_, row) => {
        copyFrom = row.id.split('cycle-')[1];
        copyTo = nextId();
        const topic = CYCLES + copyFrom;
        client.subscribe(topic, {});
        client.subscribe(topic + '/#', {});

        setTimeout((topic) => {
            client.unsubscribe(topic);
            client.unsubscribe(topic + '/#');
            copyFrom = undefined;
            copyTo = undefined;
        }, 3000, topic);
    });
}

function removeCycle(btn) {
    showModal('Удаление цикла. Все помещения, исполняющие этот цикл тоже удалятся! Удалить?', ()=> {
        $(btn).parents('.cycle-row').each((_, row) => {
            const cycleId = row.id.split('cycle-')[1];
            const topic = CYCLES + cycleId;
            onRemove = TRIGGERS.replace('+', cycleId);
            client.send(topic, '', 0, true);
            client.subscribe( onRemove + '+', {});
            setTimeout(client.unsubscribe, 2000, onRemove + '+');
        });
    });
}
