log('mercury/manager.js loaded');
var meter;

function onReady(config) {
    const client = init_client(config.broker, onConnect, onMessage);

    function onConnect() {
        meter = new meters.Meter(config.project, client);
        meter.onSelect(client);

        $('#box-3').on('click', function (e) {
            meter.checkAutoupdatePanel();
        });
        $('#energy_day').on('click', function (e) {
            var selector = $('#dayenergyselector');
            selector.change(function () {
                meter.getStoredEnergy(selector.val());
            });
            meter.getStoredEnergy(selector.val());
        });
        $('#energy_month').on('click', function (e) {
            var selector = $('#monthenergyselector');
            selector.change(function () {
                meter.getStoredEnergy(3, selector.val());
            });
            meter.getStoredEnergy(3, selector.val());
        });
        $('#energy_year').on('click', function (e) {
            var selector = $('#yearenergyselector');
            selector.change(function () {
                meter.getStoredEnergy(selector.val());
            });
            meter.getStoredEnergy(selector.val());
        });
        $('#energy_total').on('click', function (e) {
            meter.getStoredEnergy(0);
        });

        $('#update_btn').on('click', function (e) {
            if (meter) {
                meter.onUpdateClick();
            }
        });
        $('#period').find(' input').each(function (i, node) {
            $(node).on('change', function (e) {
                if (meter) {
                    meter.getPeriod(e);
                }
            });
            if (node.value) {
                node.dispatchEvent(new Event('change', {target: node}));
            }
        });
    }

    function onMessage(topic, message) {
        meter.onUpdate(topic, message);
    }
}

function setLoad(id, password) {
    request('check_password',
        function (e) {
            console.log(e);
            meter.setLoad(password);
            $('.poweronoff .password')[0].hidden = true;

        },
        function (error) {
            console.log(error);
            $('.poweronoff .password input')[0].setCustomValidity(error.error);
        },
        {
            id: id,
            password: password
        }
    );
}