import os
import signal
import threading

from django.shortcuts import render

from spread_dashboard.auth2.decorators import staff_required

BUILDS_DIR = '/tmp/spread/builds/'


@staff_required
def upgrade(request):
    if request.method == 'POST':
        has_dependencies = False
        build = handle_uploaded_file(BUILDS_DIR, request.FILES['build'])
        for fs in request.FILES.getlist('dependencies', []):
            has_dependencies = True
            handle_uploaded_file(BUILDS_DIR, fs)

        cmd = 'sudo pip3 install %s --upgrade' % build
        if has_dependencies:
            cmd += ' --no-index --find-links=%s' % BUILDS_DIR

        os.system(cmd)

        threading.Timer(interval=1, function=os.kill, args=[os.getpid(), signal.SIGTERM]).start()

        return render(request, 'project/redirector.html', dict(timeout=5, href='/spread/project/'))
    else:
        return render(request, 'version_upgrade.html')


def handle_uploaded_file(dest, f):
    os.makedirs(dest, exist_ok=True)
    filename = os.path.join(dest, f.name)
    with open(filename, 'wb+') as dest:
        for chunk in f.chunks():
            dest.write(chunk)
    return filename
