from datetime import datetime

from spread_core.protocols.utils import bytes2str


class Payload:
    mark = 'Payload'

    def __init__(self, frame: bytes):
        self.frame = frame

    def __repr__(self):
        return f'[{self.name}]: {bytes2str(self.frame)}'

    def to_dict(self):
        return dict(
            time=self.time,
            hex=bytes2str(self.frame, " "),
            name=self.name
        )

    @property
    def time(self):
        time = datetime.now()
        return time.strftime('%H:%M:%S') + f'.{str(int(time.microsecond / 1000)).ljust(3, "0")}'

    @property
    def name(self) -> str: return self.__class__.__name__

    @property
    def desc(self) -> str: return ''
